#ifndef _PARSE_OPTIONS_H_
#define _PARSE_OPTIONS_H_

#include <string>
#include <alg/mussa.hpp>

//! collect information about runtime options
struct MussaOptions 
{
  //! set defaults for our options
  MussaOptions();

  //! pointer to our analysis, if its null, feel free to die
  MussaRef analysis;
  //! Location of documentation
  std::string doc_dir;
  //! should we use the gui?
  bool useGUI;
  //! launch as python
  bool runAsPythonInterpeter;
};

//! initialize a mussa analysis from command line arguments
void initialize_mussa(MussaOptions& opts, int argc, char** argv);
#endif

