#include "qui/seqbrowser/SequenceBrowserSidebar.hpp"

using namespace std;

SequenceBrowserSidebar::SequenceBrowserSidebar(QWidget* parent)
  : QWidget(parent)
{
  setLayout(&layout);
}

void SequenceBrowserSidebar::clear()
{
  // remove our widgets
  for (SequenceBrowserSidebar::iterator desc_i = descriptions.begin();
       desc_i != descriptions.end();
       ++desc_i)
  {
    layout.removeWidget(*desc_i);
    delete *desc_i;
  }
  // remove any crud that's left over (like spacers)
  QLayoutItem *child;
  while ((child = layout.takeAt(0)) != 0) {
    layout.removeItem(child);
    delete child;
  }
  descriptions.clear();
}

SequenceBrowserSidebar::size_type SequenceBrowserSidebar::size() const
{
  return descriptions.size();
}

void SequenceBrowserSidebar::setSequences(
  vector<boost::shared_ptr<GlSequence> > sequences
)
{
  typedef vector<boost::shared_ptr<GlSequence> > vector_shared_glsequences;
  clear();
  for (vector_shared_glsequences::iterator track_i = sequences.begin();
       track_i != sequences.end();
       ++track_i)
  {
    seq_description_type desc = new SequenceDescription(this);
    desc->setGlSequence(*track_i);
    descriptions.push_back(desc);
    layout.addWidget(desc);
    if ((track_i+1) != sequences.end()) {
      layout.addStretch(1);
    }
  }
  setLayout(&layout);
}

